/*****************************  Globals   *************************************/
const nsCoxMailSMTPClassID = Components.ID("{715dd430-cd4e-11dc-95ff-0800200c9a66}");
const nsCoxMailSMTPContactID = "@mozilla.org/CoxMailSMTP;1";
const ExtCoxMailGuid = "{891cc720-cd4e-11dc-95ff-0800200c9a66}";

const szVersionNumber = "V20080217180000";

/******************************  CoxMail ***************************************/
function nsCoxMailSMTP()
{
    try
    {
        var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
        scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
        scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/Email.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/CommonPrefs.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/HttpComms3.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/base64.js");

        var date = new Date();
        var szLogFileName = "CoxMailLog_SMTP_" + date.getHours()+ "_" + date.getMinutes() + "_"+ date.getUTCMilliseconds() +"_";
        this.m_Log = new DebugLog("webmail.logging.comms", ExtCoxMailGuid, szLogFileName);

        this.m_Log.Write("nsCoxMailSMTP.js " + szVersionNumber + " - Constructor - START");

        if (typeof PATTERN_COX_MAIL_CONSTANTS == "undefined")
        {
            this.m_Log.Write("nsCoxMailSMTP.js - Constructor - loading constants");
            scriptLoader.loadSubScript("chrome://coxmail/content/CoxMail-Constants.js");
        }

        this.m_bAuthorised = false;
        this.m_bSmtpAccessible = true;
        this.m_szUserName = null;
        this.m_szRealUserName = "";
        this.m_szPassWord = null;
        this.m_oResponseStream = null;
        this.m_HttpComms = new HttpComms(this.m_Log);
        this.m_HttpComms.setUserAgentOverride(true);
        
        this.m_iStage = 0;
        this.m_iRcpt = 0;
        this.m_szEmail = null;
        this.m_Email = new email(this.m_Log);
        this.m_Email.decodeBody(true);
        this.m_aszTo = new Array;
        this.m_szFrom = null;
        
        this.m_ComponentManager = Components.classes["@mozilla.org/ComponentData2;1"]
                                            .getService(Components.interfaces.nsIComponentData2);

        //do i reuse the session
        var oPref = new Object();
        oPref.Value = null;
        var  WebMailPrefAccess = new WebMailCommonPrefAccess();
        if (WebMailPrefAccess.Get("bool","coxmail.bReUseSession",oPref))
            this.m_bReUseSession = oPref.Value;
        else
            this.m_bReUseSession = false;

        this.m_Log.Write("nsCoxMailSMTP.js - Constructor - bReUseSession : " + this.m_bReUseSession);

        //retrieve name of smtp server
        if (WebMailPrefAccess.Get("char","coxmail.szSmtpServer",oPref))
            this.m_szSmtpServer = oPref.Value;
        else
            this.m_szSmtpServer = "smtp.central.cox.net";
        this.m_Log.Write("nsCoxMailPOP.js - Constructor - szSmtpServer : " + this.m_szSmtpServer);

        //do i save copy
        /*
        var oPref = new Object();
        oPref.Value = null;
        var  PrefAccess = new WebMailCommonPrefAccess();
        if (PrefAccess.Get("bool","coxmail.bSaveCopy",oPref))
            this.m_bSaveCopy = oPref.Value;
        else
            this.m_bSaveCopy = true;
        delete oPref;
        this.m_Log.Write("nsCoxMailSMTP.js - Constructor - bSaveCopy : " + this.m_bSaveCopy);
        */

        this.m_Log.Write("nsCoxMailSMTP.js - Constructor - END");
    }
    catch(e) {
        DebugDump("nsCoxMailSMTP.js: Constructor : Exception : " + e.name + ".\nError message: " + e.message +"\n" + e.lineNumber);
    }
}

nsCoxMailSMTP.prototype =
{
    get userName() {return this.m_szUserName;},
    set userName(userName) {return this.m_szUserName = userName;},

    get passWord() {return this.m_szPassWord;},
    set passWord(passWord) {return this.m_szPassWord = passWord;},

    get bAuthorised() {return this.m_bAuthorised;},

    get ResponseStream() {return this.m_oResponseStream;},
    set ResponseStream(responseStream) {return this.m_oResponseStream = responseStream;},

    get to() {return this.m_aszTo;},
    set to(szAddress) {return this.m_aszTo.push(szAddress);},

    get from() {return this.m_szFrom;},
    set from(szAddress) {return this.m_szFrom = szAddress;},

    logIn : function()
    {
        try
        {
            this.m_Log.Write("nsCoxMailSMTP.js - logIN - START - Username: " + this.m_szUserName
                                                   + " Password: " + this.m_szPassWord
                                                   + " stream: " + this.m_oResponseStream);

            if (!this.m_szUserName || !this.m_oResponseStream  || !this.m_szPassWord) return false;

            this.m_HttpComms.setUserName(this.m_szUserName);

            var bSessionStored = this.m_ComponentManager.findElement(this.m_szUserName, "bSessionStored");
            if ( bSessionStored && this.m_bReUseSession ) 
            {
                    this.m_Log.Write("nsCoxMailSMTP.js - logIN - Session Data found");
                    this.m_bReEntry = true;
    
                    this.serverComms("+OK Session Found\r\n");
                    this.m_bAuthorised = true;
            } 
            else 
            {
                this.m_Log.Write("nsCoxMailSMTP.js - logIn - No Session Data found");
                var oCookies = Components.classes["@mozilla.org/nsWebMailCookieManager2;1"]
                                         .getService(Components.interfaces.nsIWebMailCookieManager2);
                oCookies.removeCookie(this.m_szUserName);

                this.m_ComponentManager.deleteAllElements(this.m_szUserName);
                
                // try connecting to smtp server
                this.m_Log.Write("nsCoxMailSMTP.js - logIn - attempting to connect to smtp server: " + this.m_szSmtpServer);
			    var transportService =
					Components.classes["@mozilla.org/network/socket-transport-service;1"]
				        .getService(Components.interfaces.nsISocketTransportService);
			    var transport = transportService.createTransport(null, 0, this.m_szSmtpServer, 25, null);
			    transport.setTimeout(0,5); // connect timeout of 5 seconds
			    transport.setTimeout(1,5); // read-write timeout of 5 seconds

			    var outstream = transport.openOutputStream(0,0,0);

			    var stream = transport.openInputStream(0,0,0);
    			var instream = Components.classes["@mozilla.org/scriptableinputstream;1"]
      				.createInstance(Components.interfaces.nsIScriptableInputStream);
    			instream.init(stream);
    			
    			var mainObject = this;
    
			    var smtpLoginListener = {
			    	
			    	onStartRequest: function(request, context){
						mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpLoginListener - onStartRequest");
      				},
      				
      				onStopRequest: function(request, context, status){
						mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpLoginListener - onStopRequest - status: " + status);
        				instream.close();
//        				outstream.close();
        				// check for status of 0 (success) or 8000FFFF (connection reset by peer)
        				if ( (status == 0) || (status == 2147549183) ) {
							mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpLoginListener - onStopRequest - smtp is accessible");
        					mainObject.m_bSmtpAccessible = true;
		                    mainObject.serverComms("235 login successful\r\n");
                    		mainObject.m_bAuthorised = true;
        				} else {
        					// if smtp is not accessible, proceed with login
							mainObject.m_bSmtpAccessible = false;
			                mainObject.m_HttpComms.addValuePair('client', encodeURIComponent("html"));
			   			    mainObject.m_HttpComms.addValuePair('login', encodeURIComponent("1"));
			       			mainObject.m_HttpComms.addValuePair('targetFN', encodeURIComponent("WebMail"));
			       			mainObject.m_HttpComms.addValuePair('rememberme', encodeURIComponent("false"));
			       			mainObject.m_HttpComms.addValuePair('username', encodeURIComponent(mainObject.m_szUserName));
			       			mainObject.m_HttpComms.addValuePair('emaildomain', encodeURIComponent("@cox.net"));
			       			mainObject.m_HttpComms.addValuePair('password', encodeURIComponent(mainObject.m_szPassWord));
			       			mainObject.m_HttpComms.addValuePair('onsuccess', encodeURIComponent(COX_MAIL_URL));
			       			mainObject.m_HttpComms.addValuePair('onfailure', encodeURIComponent(COX_LOGIN_FAILURE_URL));
			
			       			// this.m_HttpComms.m_bHandleBounce  = false
			
			       			mainObject.m_HttpComms.setURI(COX_LOGIN_URL);
			       			mainObject.m_HttpComms.setRequestMethod("POST");
			
			       			mainObject.m_iStage = 0;
			       			var bResult = mainObject.m_HttpComms.send(mainObject.loginOnloadHandler, mainObject);
			       			if (!bResult) {
								mainObject.m_Log.Write("nsCoxMailSMTP.js - logIn - bResult: " + bResult);
			       				throw new Error('httpConnection returned false');
			           		}
			    		}
        					
				    },

				    onDataAvailable: function(request, context, inputStream, offset, count){
				    	var inputData = instream.read(count);
						mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpLoginListener - onDataAvailable data: " + inputData);
						if (inputData.indexOf("220") == 0) {
						    var outputData = "QUIT\r\n";
							mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpLoginListener - onDataAvailable sending: " + outputData);
    						outstream.write(outputData,outputData.length);
    					}
        				
      				},
    			};

    			var pump = Components.
      							classes["@mozilla.org/network/input-stream-pump;1"].
        						createInstance(Components.interfaces.nsIInputStreamPump);
    			pump.init(stream, -1, -1, 0, 0, false);
    			pump.asyncRead(smtpLoginListener,null);
                
            }
            this.m_Log.Write("nsCoxMailSMTP.js - logIN - END");
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsCoxMailSMTP.js: logIN : Exception : "
                                              + e.name +
                                              ".\nError message: "
                                              + e.message);
            this.serverComms("502 negative vibes from " + this.m_szUserName + " msg: " + e.message + "\r\n");
            return false;
        }
    },


    loginOnloadHandler : function(szResponse ,event , mainObject)
    {
        try 
        {
            mainObject.m_Log.Write("nsCoxMailSMTP.js - loginOnloadHandler - START");
            mainObject.m_Log.Write("nsCoxMailSMTP.js - loginOnloadHandler : stage " + mainObject.m_iStage);
    
            var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
    
            //if this fails we've gone somewhere new
            var responseStatus = httpChannel.responseStatus;
            if (!responseStatus) throw new Error("missing response status");
            mainObject.m_Log.Write("nsCoxMailSMTP.js - loginOnloadHandler - status :" + responseStatus );
            if (responseStatus != 200)
                throw new Error("return status " + responseStatus);

            var aRedirect = szResponse.match(PATTERN_COX_MAIL_LOGIN_REDIRECT);
            if ( !aRedirect ) {
                this.m_bReEntry = false;
                throw new Error("Login failed. Redirect not found");
            }
        
            var szURI = decodeURIComponent(aRedirect[1]);
            if ( szURI != COX_MAIL_URL ) {
                this.m_bReEntry = false;
                throw new Error("Login failed. Wrong Userid/Password??");
            }
        
            mainObject.m_Log.Write("nsCoxMailSMTP.js - loginOnloadHandler - redirectURL " + szURI);
     
            mainObject.serverComms("235 login successful\r\n");
            mainObject.m_bAuthorised = true;

            mainObject.m_Log.Write("nsCoxMailSMTP.js - loginOnloadHandler - END");
        }
        catch(err)
        {
            var oCookies = Components.classes["@mozilla.org/nsWebMailCookieManager2;1"]
                                     .getService(Components.interfaces.nsIWebMailCookieManager2);
            oCookies.removeCookie(mainObject.m_szUserName);

            mainObject.m_ComponentManager.deleteAllElements(mainObject.m_szUserName);

            mainObject.m_Log.DebugDump("nsCoxMailSMTP.js: loginHandler : Exception : "
                                          + err.name
                                          + ".\nError message: "
                                          + err.message);

            mainObject.serverComms("502 negative vibes from " + mainObject.m_szUserName + " msg: " + err.message + "\r\n");
        }
    },

    rawMSG : function (szEmail)
    {
        try {
            this.m_Log.Write("nsCoxMailSMTP.js - rawMSG - START - " + szEmail);

            if ( this.m_bAuthorised == false ) {
                return false;
            }

            this.m_iStage =0 ;
            this.m_szEmail = szEmail;
            
            // remove duplicate addresses
            var aszTempTo = new Array;
            for (i=0; i<this.m_aszTo.length; i++) {
            	var bIsUnique = true;
            	for (j=0; j<aszTempTo.length && bIsUnique; j++) {
            		if (this.m_aszTo[i] == aszTempTo[j]) {
            			bIsUnique = false;
            		}
            	}
            	if (bIsUnique) {
            		aszTempTo[aszTempTo.length] = this.m_aszTo[i];
            	}
            }
            this.m_aszTo = aszTempTo;
            
            this.m_Log.Write("nsCoxMailSMTP.js - rawMSG - calling parse");
            if ( !this.m_Email.parse(szEmail) ) throw new Error ("Parse Failed")
            this.m_Log.Write("nsCoxMailSMTP.js - rawMSG - parse succeeded");
            
            if (this.m_bSmtpAccessible) {
                // try connecting to smtp server
                this.m_Log.Write("nsCoxMailSMTP.js - rawMSG - attempting to connect to smtp server: " + this.m_szSmtpServer);
			    var transportService =
					Components.classes["@mozilla.org/network/socket-transport-service;1"]
				        .getService(Components.interfaces.nsISocketTransportService);
			    var transport = transportService.createTransport(null, 0, this.m_szSmtpServer, 25, null);

			    var outstream = transport.openOutputStream(0,0,0);

			    var stream = transport.openInputStream(0,0,0);
    			var instream = Components.classes["@mozilla.org/scriptableinputstream;1"]
      				.createInstance(Components.interfaces.nsIScriptableInputStream);
    			instream.init(stream);
    			
    			var mainObject = this;
    
			    var smtpListener = {
			    	
			    	onStartRequest: function(request, context){
						mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onStartRequest");
      				},
      				
      				onStopRequest: function(request, context, status){
						mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onStopRequest - status: " + status);
        				instream.close();
//        				outstream.close();
        				// check for status of 0 (success) or 8000FFFF (connection reset by peer)
        				if ( (status == 0) || (status == 2147549183) ) {
		        		    mainObject.serverComms("250 OK\r\n");
							mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onStopRequest - smtp successful");
                    		mainObject.m_bAuthorised = false;
        				} else {
		        		    mainObject.serverComms("502 received status: " + status + "\r\n");
		       				throw new Error("smtpListener encountered status: " + status);
			    		}
        					
				    },

				    onDataAvailable: function(request, context, inputStream, offset, count){
				    	var inputData = instream.read(count);
						mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable  - stage " + mainObject.m_iStage + " data: " + inputData);
						
						switch  ( mainObject.m_iStage )  {
							case 0:
								if (inputData.indexOf("220") == 0) {
								    var outputData = "EHLO [127.0.0.1]\r\n";
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable sending: " + outputData);
		    						outstream.write(outputData,outputData.length);
		    					} else {
		    						throw new Error("smtpListener encountered invalid unexpected response from server: " + inputData);
		    					}
		    					mainObject.m_iStage++;
		    					break;
		    				
		    				case 1:
								if (inputData.indexOf("250") == 0) {
				                    var szFromHeader = mainObject.m_Email.headers.getHeader("from");
                				    mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable - from header: " + szFromHeader);
				                    var emailId = szFromHeader.match(PATTERN_EMAIL_ID)[1];
								    var outputData = "MAIL FROM:<" + emailId + "> SIZE=" + mainObject.m_szEmail.length + "\r\n";
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable sending: " + outputData);
		    						outstream.write(outputData,outputData.length);
		    					} else {
		    						throw new Error("smtpListener encountered invalid unexpected response from server: " + inputData);
		    					}
		    					mainObject.m_iStage++;
						        mainObject.m_iRcpt = 0;
		    					if ( mainObject.m_iRcpt >= mainObject.m_aszTo.length) {
		    						mainObject.m_iStage++;
		    					}
		    					break;
		    				
		    				case 2:
								if (inputData.indexOf("250") == 0) {
								    var outputData = "RCPT TO:<" + mainObject.m_aszTo[mainObject.m_iRcpt] + ">\r\n";
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable stage 2 iRcpt: " + mainObject.m_iRcpt + " sending: " + outputData);
		    						outstream.write(outputData,outputData.length);
		    					} else {
		    						throw new Error("smtpListener encountered invalid unexpected response from server: " + inputData);
		    					}
		    					mainObject.m_iRcpt++;
		    					if (mainObject.m_iRcpt >= mainObject.m_aszTo.length) {
		    						mainObject.m_iStage++;
		    					}
		    					break;
		    				
							case 3:
								if (inputData.indexOf("250") == 0) {
								    var outputData = "DATA\r\n";
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable sending: " + outputData);
		    						outstream.write(outputData,outputData.length);
		    					} else {
		    						throw new Error("smtpListener encountered invalid unexpected response from server: " + inputData);
		    					}
		    					mainObject.m_iStage++;
		    					break;
		    				
							case 4:
								if (inputData.indexOf("354") == 0) {
								    //var outputData = mainObject.m_szEmail.replace("\r\n\.", "\r\n\..") + ".\r\n";
								    var outputData = mainObject.m_szEmail;
									//mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable isNonBlocking: " + outstream.isNonBlocking());
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable sending: " + outputData);
									var currentLocation = 0;
									var outputLength = outputData.length;
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable outputLength: " + outputLength);
									while (currentLocation < outputLength) {
										mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable currentLocation: " + currentLocation);
										var numWritten = outstream.write(outputData.substring(currentLocation, outputLength), outputLength-currentLocation);
										mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable numWritten: " + numWritten);
										currentLocation += numWritten;
									}
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable currentLocation = outputLength ");
		    					} else {
		    						throw new Error("smtpListener encountered invalid unexpected response from server: " + inputData);
		    					}
		    					mainObject.m_iStage++;
		    					break;
		    				
							case 5:
								if (inputData.indexOf("250") == 0) {
								    var outputData = "QUIT\r\n";
									mainObject.m_Log.Write("nsCoxMailSMTP.js - smtpListener - onDataAvailable sending: " + outputData);
		    						outstream.write(outputData,outputData.length);
				        		    //mainObject.serverComms("250 OK\r\n");
		    					} else {
		    						throw new Error("smtpListener encountered invalid unexpected response from server: " + inputData);
		    					}
		    					mainObject.m_iStage++;
		    					break;
		    				
							case 6:
								// do nothing
		    					break;
		    				
			            }
      				},
    			};

    			var pump = Components.
      							classes["@mozilla.org/network/input-stream-pump;1"].
        						createInstance(Components.interfaces.nsIInputStreamPump);
    			pump.init(stream, -1, -1, 0, 0, false);
    			pump.asyncRead(smtpListener,null);
                
        	} else {

	            this.m_HttpComms.setURI(COX_MAIL_URL);
	            this.m_HttpComms.setRequestMethod("GET");
	            var bResult = this.m_HttpComms.send(this.composerOnloadHandler, this);
	            if ( !bResult ) {
	                throw new Error("httpConnection returned false");
	            }
	        }
            this.m_Log.Write("nsCoxMailSMTP.js - rawMSG - END");
            return true;
        }
        catch(err) {
            this.m_Log.DebugDump("nsCoxMailSMTP.js: rawMSG : Exception : " + err.name + ".\nError message: " + err.message+ "\n" + err.lineNumber);
            return false;
        }
    },
    
    composerOnloadHandler : function(szResponse ,event , mainObject)
    {
        try {
            mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - START");
            mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler : " + mainObject.m_iStage);

            var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

            //if this fails we've gone somewhere new
            mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - status :" + httpChannel.responseStatus );
            if (httpChannel.responseStatus != 200) {
                throw new Error("return status " + httpChannel.responseStatus);
            }

            switch  ( mainObject.m_iStage ) 
            {
                case 0:
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - folder view");

					if (szResponse.indexOf(COX_MAIL_INBOX_TITLE) < 0) {
						throw new Error("Invalid title on Inbox page");
					}

                    mainObject.m_HttpComms.setURI(COX_MAIL_MESSAGE_COMPOSE_URL);
                    mainObject.m_HttpComms.setRequestMethod("GET");
                    var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
                    if (!bResult) throw new Error("httpConnection returned false");
        
                    mainObject.m_iStage++;
               break;
               
               case 1:
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - message compose");
                    
					if (szResponse.indexOf(COX_MAIL_MESSAGE_COMPOSE_TITLE) < 0) {
						throw new Error("Invalid title on message compose page");
					}

                    //this.m_szRealUserName = szResponse.match(/<input type=\"hidden\" name=\"fromName\" value=\"(.*?)\">/)[1];
                    var szFromHeader = mainObject.m_Email.headers.getHeader("from");
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - from header: " + szFromHeader);

                    mainObject.m_szRealUserName = szFromHeader.match(PATTERN_REAL_USERNAME)[1];
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - real user name: " + mainObject.m_szRealUserName);

					if (mainObject.isHtml(mainObject)) {
						mainObject.addEmptyValuePairsForEmail(mainObject);
                    	mainObject.m_HttpComms.setURI(COX_MAIL_MESSAGE_HTML_COMPOSE_URL);
	                    mainObject.m_HttpComms.setRequestMethod("POST");
		                var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
    		            if (!bResult) throw new Error("httpConnection returned false");
            	        mainObject.m_iStage++;
            	    } else if (mainObject.hasAttachments(mainObject)) {
            	    	mainObject.addEmptyValuePairsForEmail(mainObject);
                    	mainObject.m_HttpComms.setURI(COX_MAIL_ADD_ATTACHMENT_URL);
	                    mainObject.m_HttpComms.setRequestMethod("POST");
		                var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
    		            if (!bResult) throw new Error("httpConnection returned false");
            	        mainObject.m_iStage += 2;
	            	} else {
	            		mainObject.addValuePairsForEmail(mainObject);
                    	mainObject.m_HttpComms.setURI(COX_MAIL_MESSAGE_SEND_URL);
	                    mainObject.m_HttpComms.setRequestMethod("POST");
   		                var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
       		            if (!bResult) throw new Error("httpConnection returned false");
	            		mainObject.m_iStage += 4;
	            	}
               break;
               
               case 2:
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - message htmlEditor");

					if (szResponse.indexOf(COX_MAIL_MESSAGE_HTML_COMPOSE_TITLE) < 0) {
						throw new Error("Invalid title on html message compose page");
					}

            	    if (mainObject.hasAttachments(mainObject)) {
            	    	mainObject.addEmptyValuePairsForEmail(mainObject);
                    	mainObject.m_HttpComms.setURI(COX_MAIL_ADD_ATTACHMENT_URL);
	                    mainObject.m_HttpComms.setRequestMethod("POST");
		                var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
    		            if (!bResult) throw new Error("httpConnection returned false");
            	        mainObject.m_iStage++;
	            	} else {
	            		mainObject.addValuePairsForEmail(mainObject);
                    	mainObject.m_HttpComms.setURI(COX_MAIL_MESSAGE_SEND_URL);
	                    mainObject.m_HttpComms.setRequestMethod("POST");
   		                var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
       		            if (!bResult) throw new Error("httpConnection returned false");
	            		mainObject.m_iStage += 3;
	            	}
                break;
               
               case 3:
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - message addAttachment");

					if (szResponse.indexOf(COX_MAIL_MESSAGE_ADD_ATTACHMENT_TITLE) < 0) {
						throw new Error("Invalid title on add attachment page");
					}

					for (var i=0; i < mainObject.m_Email.attachments.length; i++) {
						var szFileName = mainObject.m_Email.attachments[i].headers.getContentType(4);
						if (szFileName) {
							// do nothing
						} else {
							szFileName = "unknown";
						}
	                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - adding attachment " + szFileName);
						mainObject.m_HttpComms.addFile("attachment[" + i + "]", szFileName, mainObject.m_Email.attachments[i].body.getBody() );	
					}

           			mainObject.m_HttpComms.addValuePair('blank', encodeURIComponent(""));
                    mainObject.m_HttpComms.setURI(COX_MAIL_SAVE_ATTACHMENT_URL);
                    mainObject.m_HttpComms.setContentType("multipart/form-data");
                    mainObject.m_HttpComms.setRequestMethod("POST");
                    var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
                    if (!bResult) throw new Error("httpConnection returned false");
        
                    mainObject.m_iStage++;
                break;
               
               case 4:
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - message composer");

            		mainObject.addValuePairsForEmail(mainObject);
                	mainObject.m_HttpComms.setURI(COX_MAIL_MESSAGE_SEND_URL);
                    mainObject.m_HttpComms.setRequestMethod("POST");
	                var bResult = mainObject.m_HttpComms.send(mainObject.composerOnloadHandler, mainObject);
   		            if (!bResult) throw new Error("httpConnection returned false");
                    mainObject.m_iStage++;
                break;
               
               case 5:
                    mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - message htmlEditor");

					if (szResponse.indexOf(COX_MAIL_INBOX_TITLE) < 0) {
						throw new Error("Invalid title on Inbox page after send");
					}

            		if ( mainObject.m_bReUseSession) {
        		        mainObject.m_Log.Write("nsCoxMailSMTP.js - loginOnloadHandler - Saving session Data");
		                mainObject.m_ComponentManager.addElement(mainObject.m_szUserName, "bSessionStored", true);
            		} else {
        		        var oCookies = Components.classes["@mozilla.org/nsWebMailCookieManager2;1"]
                                         .getService(Components.interfaces.nsIWebMailCookieManager2);
		                oCookies.removeCookie(mainObject.m_szUserName);

        		        mainObject.m_ComponentManager.deleteAllElements(mainObject.m_szUserName);
		            }

        		    mainObject.serverComms("250 OK\r\n");
		            mainObject.m_Log.Write("nsCoxMailSMTP.js - composerOnloadHandler - END");
                break;
            }
        }
        catch(err) {
            mainObject.m_Log.DebugDump("nsCoxMailSMTP.js: composerOnloadHandler : Exception : " + err.name + ".\nError message: " + err.message + "\n" + err.lineNumber);
            mainObject.serverComms("502 " + err.message + " sending mail from " + mainObject.m_szUserName + "\r\n");
        }
    },

    isHtml : function(mainObject)
    {
		if (mainObject.m_Email.htmlBody) {
			return true;
		} else {
			return false;
		}
    },

    hasAttachments : function(mainObject)
    {
		if (mainObject.m_Email.attachments.length > 0) {
			return true;
		} else {
			return false;
		}
    },

    addEmptyValuePairsForEmail : function(mainObject)
    {
		mainObject.m_HttpComms.addValuePair('fromName', encodeURIComponent(mainObject.m_szRealUserName));
		mainObject.m_HttpComms.addValuePair('context', encodeURIComponent("new"));
		mainObject.m_HttpComms.addValuePair('body', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('attFileName', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('msgType', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('msgLength', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('signature', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('referrer', encodeURIComponent("list"));
		mainObject.m_HttpComms.addValuePair('h2Z', encodeURIComponent("false"));
		mainObject.m_HttpComms.addValuePair('autoSpellCheckEnabled', encodeURIComponent("false"));
		mainObject.m_HttpComms.addValuePair('selectedFrom', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('to', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('cc', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('bcc', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('subject', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('textareaPlainText', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('saveCopy', encodeURIComponent("1"));
		mainObject.m_HttpComms.addValuePair('saveCopyFlag', encodeURIComponent("checked"));
		mainObject.m_HttpComms.addValuePair('requestReturnReceipt', encodeURIComponent("0"));
		mainObject.m_HttpComms.addValuePair('requestReturnReceiptFlag', encodeURIComponent("checked"));
		mainObject.m_HttpComms.addValuePair('priority', encodeURIComponent("Normal"));
		mainObject.m_HttpComms.addValuePair('sensitivity', encodeURIComponent("normal"));
    },

    addValuePairsForEmail : function(mainObject)
    {
		mainObject.m_HttpComms.addValuePair('fromName', encodeURIComponent(mainObject.m_szRealUserName));
		mainObject.m_HttpComms.addValuePair('context', encodeURIComponent("new"));
		
		var szBody = "";
		if (mainObject.isHtml(mainObject)) {
			szBody = mainObject.m_Email.htmlBody.body.getBody();
		}
		mainObject.m_HttpComms.addValuePair('body', szBody);

		mainObject.m_HttpComms.addValuePair('attFileName', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('msgType', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('msgLength', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('signature', encodeURIComponent(""));
		mainObject.m_HttpComms.addValuePair('referrer', encodeURIComponent("list"));
		mainObject.m_HttpComms.addValuePair('h2Z', encodeURIComponent("false"));
		mainObject.m_HttpComms.addValuePair('autoSpellCheckEnabled', encodeURIComponent("false"));
		mainObject.m_HttpComms.addValuePair('selectedFrom', encodeURIComponent(mainObject.m_szFrom));
		
		var szTo = mainObject.m_Email.headers.getTo();
		szTo = szTo ? szTo : "";
		mainObject.m_HttpComms.addValuePair('to', encodeURIComponent(szTo));

		var szCc = mainObject.m_Email.headers.getCc();
		szCc = szCc ? szCc : "";
		mainObject.m_HttpComms.addValuePair('cc', encodeURIComponent(szCc));

		var szBcc = mainObject.getBcc(szTo, szCc);
		szBcc = szBcc ? szBcc : "";
		mainObject.m_HttpComms.addValuePair('bcc', encodeURIComponent(szBcc));
		
		var szSubject = mainObject.m_Email.headers.getSubject();
		szSubject = szSubject ? szSubject : " ";
		mainObject.m_HttpComms.addValuePair('subject', encodeURIComponent(szSubject));

		if (mainObject.isHtml(mainObject)) {
			var szPlainText = "";
			if (mainObject.m_Email.txtBody) {
				szPlainText = mainObject.m_Email.txtBody.body.getBody();
			}
			mainObject.m_HttpComms.addValuePair('plainText', encodeURIComponent(szPlainText));
		} else {
			var szTextareaPlainText = "";
			if (mainObject.m_Email.txtBody) {
				szTextareaPlainText = mainObject.m_Email.txtBody.body.getBody();
			}
			mainObject.m_HttpComms.addValuePair('textareaPlainText', encodeURIComponent(szTextareaPlainText));
		}
		mainObject.m_HttpComms.addValuePair('saveCopy', encodeURIComponent("1"));
		mainObject.m_HttpComms.addValuePair('saveCopyFlag', encodeURIComponent("checked"));
		mainObject.m_HttpComms.addValuePair('requestReturnReceipt', encodeURIComponent("0"));
		//mainObject.m_HttpComms.addValuePair('requestReturnReceiptFlag', encodeURIComponent("checked"));
		mainObject.m_HttpComms.addValuePair('priority', encodeURIComponent("Normal"));
		mainObject.m_HttpComms.addValuePair('sensitivity', encodeURIComponent("normal"));
    },

    escapeStr : function(szMSG)
    {
        var szEncode = escape(szMSG);
        szEncode = szEncode.replace(/%20/gm,"+"); //replace space
        return szEncode;
    },

    getBcc : function (szTo,szCc)
    {
        try
        {
            this.m_Log.Write("nsCoxMailSMTP.js - getBcc - START");
            if (this.m_aszTo.length==0) return null;
            this.m_Log.Write("nsCoxMailSMTP.js - getBcc - szRcptList " + this.m_aszTo);

            var szBcc = null;
            var szAddress = null;
            if (szTo) szAddress = szTo;
            if (szCc) szAddress = (szTo ? (szAddress + ","+ szCc) : szCc);
            this.m_Log.Write("nsCoxMailSMTP.js - getBcc - szAddress " + szAddress);

            if (!szAddress)
                szBcc = this.m_aszTo;
            else
            {
                for (j=0; j<this.m_aszTo.length; j++)
                {
                    var regExp = new RegExp(this.m_aszTo[j]);
                    if (szAddress.search(regExp)==-1)
                    {
                        szBcc? (szBcc += this.m_aszTo[j]) : (szBcc = this.m_aszTo[j]);
                        szBcc +=",";
                    }
                }
            }
            this.m_Log.Write("nsCoxMailSMTP.js - getBcc szBcc- " + szBcc);

            this.m_Log.Write("nsCoxMailSMTP.js - getBcc - End");
            return szBcc;
        }
        catch(err)
        {
            this.m_Log.DebugDump("nsCoxMailSMTP.js: getBcc : Exception : "
                                                  + err.name
                                                  + ".\nError message: "
                                                  + err.message + "\n"
                                                  + err.lineNumber);

            return null;
        }
    },



    convertToUTF8 : function (szRawMSG, szCharset)
    {
        this.m_Log.Write("nsCoxMailSMTP - convertToUTF8 START " +szCharset );

        var aszCharset = new Array( "ISO-2022-CN" , "ISO-2022-JP"  , "ISO-2022-KR" , "ISO-8859-1"  , "ISO-8859-10",
                                    "ISO-8859-11" , "ISO-8859-12"  , "ISO-8859-13" , "ISO-8859-14" , "ISO-8859-15",
                                    "ISO-8859-16" , "ISO-8859-2"   , "ISO-8859-3"  , "ISO-8859-4"  , "ISO-8859-5" ,
                                    "ISO-8859-6"  , "ISO-8859-6-E" , "ISO-8859-6-I", "ISO-8859-7"  , "ISO-8859-8" ,
                                    "ISO-8859-8-E", "ISO-8859-8-I" , "ISO-8859-9"  , "ISO-IR-111"  ,
                                    "UTF-8"       , "UTF-16"       , "UTF-16BE"    , "UTF-16LE"    , "UTF-32BE"   ,
                                    "UTF-32LE"    , "UTF-7"        ,
                                    "IBM850"      , "IBM852"       , "IBM855"      , "IBM857"      , "IBM862"     ,
                                    "IBM864"      , "IBM864I"      , "IBM866"      ,
                                    "WINDOWS-1250", "WINDOWS-1251" , "WINDOWS-1252", "WINDOWS-1253", "WINDOWS-1254",
                                    "WINDOWS-1255", "WINDOWS-1256" , "WINDOWS-1257", "WINDOWS-1258", "WINDOWS-874" ,
                                    "WINDOWS-936" ,
                                    "BIG5"        , "BIG5-HKSCS"   , "EUC-JP"      , "EUC-KR"      , "GB2312"     ,
                                    "X-GBK"       , "GB18030"      , "HZ-GB-2312"  , "ARMSCII-8"   , "GEOSTD8"    ,
                                    "KOI8-R"      , "KOI8-U"       , "SHIFT_JIS"   , "T.61-8BIT"   , "TIS-620"    ,
                                    "US-ASCII"    , "VIQR"         , "VISCII"      ,
                                    "X-EUC-TW"       , "X-JOHAB"                , "X-MAC-ARABIC"          , "X-MAC-CE"       ,
                                    "X-MAC-CROATIAN" , "X-MAC-GREEK"            , "X-MAC-HEBREW"          , "X-MAC-ROMAN"    ,
                                    "X-MAC-TURKISH"  , "X-MAC-ICELANDIC"        , "X-U-ESCAPED"           , "X-MAC-CYRILLIC" ,
                                    "X-MAC-UKRAINIAN", "X-MAC-ROMANIAN"         , "X-OBSOLETED-EUC-JP"    , "X-USER-DEFINED" ,
                                    "X-VIET-VNI"     , "X-VIET-VPS"             , "X-IMAP4-MODIFIED-UTF7" , "X-VIET-TCVN5712",
                                    "X-WINDOWS-949"  , "X-OBSOLETED-ISO-2022-JP", "X-OBSOLETED-SHIFT_JIS"
                                  );

        var szUseCharSet = "US-ASCII";
        var i = 0;
        var bFound = false;
        do{
            if (aszCharset[i] == szCharset.toUpperCase())
            {
                bFound = true;
                szUseCharSet =  szCharset.toUpperCase();
            }
            i++;
        }while (i<aszCharset.length && !bFound)
        this.m_Log.Write("nsCoxMailSMTP - convertToUTF8 use charset " + szUseCharSet);

        var Converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                                  .getService(Components.interfaces.nsIScriptableUnicodeConverter);
        Converter.charset =  szUseCharSet;
        var unicode =  Converter.ConvertToUnicode(szRawMSG);
        Converter.charset = "UTF-8";
        var szDecoded = Converter.ConvertFromUnicode(unicode)+ Converter.Finish();
        this.m_Log.Write("nsCoxMailSMTP - convertToUTF8 - "+szDecoded);

        this.m_Log.Write("nsCoxMailSMTP - convertToUTF8 END");
        return szDecoded;
    },


    ////////////////////////////////////////////////////////////////////////////
    /////  Comms

    serverComms : function (szMsg)
    {
        try
        {
            this.m_Log.Write("nsCoxMailSMTP.js - serverComms - START");
            this.m_Log.Write("nsCoxMailSMTP.js - serverComms msg " + szMsg);
            var iCount = this.m_oResponseStream.write(szMsg,szMsg.length);
            this.m_Log.Write("nsCoxMailSMTP.js - serverComms sent count: " + iCount
                                                        +" msg length: " +szMsg.length);
            this.m_Log.Write("nsCoxMailSMTP.js - serverComms - END");
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsCoxMailSMTP.js: serverComms : Exception : "
                                              + e.name
                                              + ".\nError message: "
                                              + e.message+ "\n"
                                              + e.lineNumber);
        }
    },


/******************************************************************************/
/***************** XPCOM  stuff ***********************************************/
/******************************************************************************/
    QueryInterface : function (iid)
    {
        if (!iid.equals(Components.interfaces.nsISMTPDomainHandler)
                            && !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;

        return this;
    }
}


/******************************************************************************/
/* FACTORY*/
var nsCoxMailSMTPFactory = new Object();

nsCoxMailSMTPFactory.createInstance = function (outer, iid)
{
    if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;

    if (!iid.equals(nsCoxMailSMTPClassID) && !iid.equals(Components.interfaces.nsISupports))
        throw Components.results.NS_ERROR_INVALID_ARG;

    return new nsCoxMailSMTP();
}


/******************************************************************************/
/* MODULE */
var nsCoxMailSMTPModule = new Object();

nsCoxMailSMTPModule.registerSelf = function(compMgr, fileSpec, location, type)
{
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(nsCoxMailSMTPClassID,
                                    "CoxMailSMTPComponent",
                                    nsCoxMailSMTPContactID,
                                    fileSpec,
                                    location,
                                    type);
}


nsCoxMailSMTPModule.unregisterSelf = function(aCompMgr, aFileSpec, aLocation)
{
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(nsCoxMailSMTPClassID, aFileSpec);
}


nsCoxMailSMTPModule.getClassObject = function(compMgr, cid, iid)
{
    if (!cid.equals(nsCoxMailSMTPClassID))
        throw Components.results.NS_ERROR_NO_INTERFACE;

    if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    return nsCoxMailSMTPFactory;
}


nsCoxMailSMTPModule.canUnload = function(compMgr)
{
    return true;
}
/******************************************************************************/


function NSGetModule(compMgr, fileSpec)
{
    return nsCoxMailSMTPModule;
}
