const cszCoxMailPOPContentID = "@mozilla.org/CoxMailPOP;1";
const cszCoxMailSMTPContentID = "@mozilla.org/CoxMailSMTP;1";


window.addEventListener("load", function() {gCoxMailStartUp.init();} , false);

var gCoxMailStartUp =
{
	m_DomainManager : null,
	m_Log : null,
	m_Timer : null,

	init : function ()
	{
		try {
			//create debug log global 
			this.m_Log = new DebugLog("webmail.logging.comms", "{3c8e8390-2cf6-11d9-9669-0800200c9a66}", "CoxMail");

			this.m_Log.Write("CoxMail.js : CoxMailStartUp - START");

			var iCount = this.windowCount();
			if (iCount >1) {
				this.m_Log.Write("CoxMail.js : - another window - END");
				return;
			}

			try  {
				this.m_DomainManager = Components.classes["@mozilla.org/DomainManager;1"].getService().QueryInterface(Components.interfaces.nsIDomainManager);
			}
			catch(err) {
				window.removeEventListener("load", function() {gCoxMailStartUp.init();} , false);
				throw new Error("Domain Manager Not Found");
			}

			this.m_Timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer); 
			this.m_Timer.initWithCallback(this, 2000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
			this.m_Log.Write("CoxMail.js : CoxMailStartUp - DB not loaded");

			window.removeEventListener("load", function() {gCoxMailStartUp.init();} , false);
			this.m_Log.Write("CoxMail.js : CoxMailStartUP - END ");
		}
		catch(e) {
			this.m_Log.DebugDump("CoxMail.js : Exception in CoxMailStartUp " + e.name + ".\nError message: " + e.message);
		}
	},

	notify: function(timer)
	{
		try {
			this.m_Log.Write("CoxMail.js : TimerCallback -  START");

			if( !this.m_DomainManager.isReady() ) {
				this.m_Log.Write("CoxMail.js : TimerCallback -  db not ready");
				return;
			}
			timer.cancel();

			//get store ids
			this.idCheck("cox.net", "POP", cszCoxMailPOPContentID);
			this.idCheck("cox.net", "SMTP", cszCoxMailSMTPContentID);

			this.m_Log.Write("CoxMail.js : TimerCallback - END");
		}
		catch(e) {
			this.m_Log.DebugDump("CoxMail.js : TimerCallback - Exception in notify : " + e.name + ".\nError message: " + e.message);
		}
	},

	idCheck : function(szDomain, szProtocol, szCoxMailContentID)
	{
		this.m_Log.Write("CoxMail.js : idCheck - START");
		this.m_Log.Write("CoxMail.js : idCheck - " +szDomain + " " + szProtocol+ " " + szCoxMailContentID);

		var szContentID = new Object;
		if (this.m_DomainManager.getDomainForProtocol(szDomain,szProtocol, szContentID)) {
			this.m_Log.Write("CoxMail.js : idCheck - found");
			if (szContentID.value != szCoxMailContentID) {
				this.m_Log.Write("CoxMail.js : idCheck - wrong id");
				this.m_DomainManager.newDomainForProtocol(szDomain, szProtocol, szCoxMailContentID);
			}
		} else {
			this.m_Log.Write("CoxMail.js : idCheck - not found");
			this.m_DomainManager.newDomainForProtocol(szDomain, szProtocol, szCoxMailContentID);
		}

		this.m_Log.Write("CoxMail.js : idCheck - END");
	},

	windowCount : function()
	{
		try {
			this.m_Log.Write("CoxMail.js : windowCount - START");
			
			var iWindowCount = 0;
			var winman = Components.classes["@mozilla.org/appshell/window-mediator;1"];
			winman = winman.getService(Components.interfaces.nsIWindowMediator);
			var e = winman.getEnumerator(null);

			while ( e.hasMoreElements() ) {
				var win = e.getNext();
				win.QueryInterface(Components.interfaces.nsIDOMWindowInternal);
				var szValue = win.document.documentElement.getAttribute("id");
				this.m_Log.Write("CoxMail.js : windowCount - "+ szValue);
				if (szValue =="messengerWindow")
					iWindowCount++;
			}
			this.m_Log.Write("CoxMail.js : windowCount - "+ iWindowCount +" END ");
			return iWindowCount;
		}
		catch(e) {
			this.m_Log.DebugDump("CoxMail.js : Exception in shutDown " + e.name + ".\nError message: " + e.message);
		}
	},

};

